//{{{
module AES_MIXCOLUMNS(x, y);

input [127:0] x;

output [127:0] y;

MIXCOLUMNS mixcolumns0(.x(x[127: 96]), .y(y[127: 96]));
MIXCOLUMNS mixcolumns1(.x(x[ 95: 64]), .y(y[ 95: 64]));
MIXCOLUMNS mixcolumns2(.x(x[ 63: 32]), .y(y[ 63: 32]));
MIXCOLUMNS mixcolumns3(.x(x[ 31:  0]), .y(y[ 31:  0]));

endmodule
//}}}

//{{{
module MIXCOLUMNS(x, y);
  input  [31:0]  x;
  output [31:0]  y;

  wire [7:0] a3, a2, a1, a0, b3, b2, b1, b0;

  assign a3 = x[31:24]; assign a2 = x[23:16];
  assign a1 = x[15: 8]; assign a0 = x[ 7: 0];

  assign b3 = a3 ^ a2; assign b2 = a2 ^ a1;
  assign b1 = a1 ^ a0; assign b0 = a0 ^ a3;

  assign y = {a2[7] ^ b1[7] ^ b3[6],         a2[6] ^ b1[6] ^ b3[5],
              a2[5] ^ b1[5] ^ b3[4],         a2[4] ^ b1[4] ^ b3[3] ^ b3[7],
              a2[3] ^ b1[3] ^ b3[2] ^ b3[7], a2[2] ^ b1[2] ^ b3[1],
              a2[1] ^ b1[1] ^ b3[0] ^ b3[7], a2[0] ^ b1[0] ^ b3[7],
              a3[7] ^ b1[7] ^ b2[6],         a3[6] ^ b1[6] ^ b2[5],
              a3[5] ^ b1[5] ^ b2[4],         a3[4] ^ b1[4] ^ b2[3] ^ b2[7],
              a3[3] ^ b1[3] ^ b2[2] ^ b2[7], a3[2] ^ b1[2] ^ b2[1],
              a3[1] ^ b1[1] ^ b2[0] ^ b2[7], a3[0] ^ b1[0] ^ b2[7],
              a0[7] ^ b3[7] ^ b1[6],         a0[6] ^ b3[6] ^ b1[5],
              a0[5] ^ b3[5] ^ b1[4],         a0[4] ^ b3[4] ^ b1[3] ^ b1[7],
              a0[3] ^ b3[3] ^ b1[2] ^ b1[7], a0[2] ^ b3[2] ^ b1[1],
              a0[1] ^ b3[1] ^ b1[0] ^ b1[7], a0[0] ^ b3[0] ^ b1[7],
              a1[7] ^ b3[7] ^ b0[6],         a1[6] ^ b3[6] ^ b0[5],
              a1[5] ^ b3[5] ^ b0[4],         a1[4] ^ b3[4] ^ b0[3] ^ b0[7],
              a1[3] ^ b3[3] ^ b0[2] ^ b0[7], a1[2] ^ b3[2] ^ b0[1],
              a1[1] ^ b3[1] ^ b0[0] ^ b0[7], a1[0] ^ b3[0] ^ b0[7]};
endmodule
//}}}

module AES_SUBBYTES (x, y);
  input  [127:0] x;
  output [127:0] y;

  SBOX Sbox0(.x(x[127:120]), .y(y[127:120]));
  SBOX Sbox1(.x(x[119:112]), .y(y[119:112]));
  SBOX Sbox2(.x(x[111:104]), .y(y[111:104]));
  SBOX Sbox3(.x(x[103: 96]), .y(y[103: 96]));
  SBOX Sbox4(.x(x[ 95: 88]), .y(y[ 95: 88]));
  SBOX Sbox5(.x(x[ 87: 80]), .y(y[ 87: 80]));
  SBOX Sbox6(.x(x[ 79: 72]), .y(y[ 79: 72]));
  SBOX Sbox7(.x(x[ 71: 64]), .y(y[ 71: 64]));
  SBOX Sbox8(.x(x[ 63: 56]), .y(y[ 63: 56]));
  SBOX Sbox9(.x(x[ 55: 48]), .y(y[ 55: 48]));
  SBOX Sboxa(.x(x[ 47: 40]), .y(y[ 47: 40]));
  SBOX Sboxb(.x(x[ 39: 32]), .y(y[ 39: 32]));
  SBOX Sboxc(.x(x[ 31: 24]), .y(y[ 31: 24]));
  SBOX Sboxd(.x(x[ 23: 16]), .y(y[ 23: 16]));
  SBOX Sboxe(.x(x[ 15:  8]), .y(y[ 15:  8]));
  SBOX Sboxf(.x(x[  7:  0]), .y(y[  7:  0]));

endmodule
